// Auto-generated. Do not edit!

// (in-package planner_cspace_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let geometry_msgs = _finder('geometry_msgs');

//-----------------------------------------------------------

class MoveWithToleranceGoal {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.target_pose = null;
      this.goal_tolerance_lin = null;
      this.goal_tolerance_ang = null;
      this.goal_tolerance_ang_finish = null;
      this.continuous_movement_mode = null;
    }
    else {
      if (initObj.hasOwnProperty('target_pose')) {
        this.target_pose = initObj.target_pose
      }
      else {
        this.target_pose = new geometry_msgs.msg.PoseStamped();
      }
      if (initObj.hasOwnProperty('goal_tolerance_lin')) {
        this.goal_tolerance_lin = initObj.goal_tolerance_lin
      }
      else {
        this.goal_tolerance_lin = 0.0;
      }
      if (initObj.hasOwnProperty('goal_tolerance_ang')) {
        this.goal_tolerance_ang = initObj.goal_tolerance_ang
      }
      else {
        this.goal_tolerance_ang = 0.0;
      }
      if (initObj.hasOwnProperty('goal_tolerance_ang_finish')) {
        this.goal_tolerance_ang_finish = initObj.goal_tolerance_ang_finish
      }
      else {
        this.goal_tolerance_ang_finish = 0.0;
      }
      if (initObj.hasOwnProperty('continuous_movement_mode')) {
        this.continuous_movement_mode = initObj.continuous_movement_mode
      }
      else {
        this.continuous_movement_mode = false;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type MoveWithToleranceGoal
    // Serialize message field [target_pose]
    bufferOffset = geometry_msgs.msg.PoseStamped.serialize(obj.target_pose, buffer, bufferOffset);
    // Serialize message field [goal_tolerance_lin]
    bufferOffset = _serializer.float64(obj.goal_tolerance_lin, buffer, bufferOffset);
    // Serialize message field [goal_tolerance_ang]
    bufferOffset = _serializer.float64(obj.goal_tolerance_ang, buffer, bufferOffset);
    // Serialize message field [goal_tolerance_ang_finish]
    bufferOffset = _serializer.float64(obj.goal_tolerance_ang_finish, buffer, bufferOffset);
    // Serialize message field [continuous_movement_mode]
    bufferOffset = _serializer.bool(obj.continuous_movement_mode, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type MoveWithToleranceGoal
    let len;
    let data = new MoveWithToleranceGoal(null);
    // Deserialize message field [target_pose]
    data.target_pose = geometry_msgs.msg.PoseStamped.deserialize(buffer, bufferOffset);
    // Deserialize message field [goal_tolerance_lin]
    data.goal_tolerance_lin = _deserializer.float64(buffer, bufferOffset);
    // Deserialize message field [goal_tolerance_ang]
    data.goal_tolerance_ang = _deserializer.float64(buffer, bufferOffset);
    // Deserialize message field [goal_tolerance_ang_finish]
    data.goal_tolerance_ang_finish = _deserializer.float64(buffer, bufferOffset);
    // Deserialize message field [continuous_movement_mode]
    data.continuous_movement_mode = _deserializer.bool(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += geometry_msgs.msg.PoseStamped.getMessageSize(object.target_pose);
    return length + 25;
  }

  static datatype() {
    // Returns string type for a message object
    return 'planner_cspace_msgs/MoveWithToleranceGoal';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '0319165dc02e0dd05ac4be01ecaae88a';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
    geometry_msgs/PoseStamped target_pose
    float64 goal_tolerance_lin
    float64 goal_tolerance_ang         # An angle tolerance to the goal point from the robot.
    float64 goal_tolerance_ang_finish  # An angle tolerance that the robot on the goal point should direct to a certain angle.
    bool continuous_movement_mode      # Set to true to send a next goal continuously. Read https://github.com/at-wat/neonavigation/pull/652 for detailed explanation.
    
    ================================================================================
    MSG: geometry_msgs/PoseStamped
    # A Pose with reference coordinate frame and timestamp
    Header header
    Pose pose
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: geometry_msgs/Pose
    # A representation of pose in free space, composed of position and orientation. 
    Point position
    Quaternion orientation
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new MoveWithToleranceGoal(null);
    if (msg.target_pose !== undefined) {
      resolved.target_pose = geometry_msgs.msg.PoseStamped.Resolve(msg.target_pose)
    }
    else {
      resolved.target_pose = new geometry_msgs.msg.PoseStamped()
    }

    if (msg.goal_tolerance_lin !== undefined) {
      resolved.goal_tolerance_lin = msg.goal_tolerance_lin;
    }
    else {
      resolved.goal_tolerance_lin = 0.0
    }

    if (msg.goal_tolerance_ang !== undefined) {
      resolved.goal_tolerance_ang = msg.goal_tolerance_ang;
    }
    else {
      resolved.goal_tolerance_ang = 0.0
    }

    if (msg.goal_tolerance_ang_finish !== undefined) {
      resolved.goal_tolerance_ang_finish = msg.goal_tolerance_ang_finish;
    }
    else {
      resolved.goal_tolerance_ang_finish = 0.0
    }

    if (msg.continuous_movement_mode !== undefined) {
      resolved.continuous_movement_mode = msg.continuous_movement_mode;
    }
    else {
      resolved.continuous_movement_mode = false
    }

    return resolved;
    }
};

module.exports = MoveWithToleranceGoal;
